//XBOB4EncInt.h
#ifndef XBOB4ENCINT_H
#define XBOB4ENCINT_H

#define VERSION_STRING	"BOB-4 SEI V1.7"

#define TRUE 			1
#define FALSE 			0
//CPU frequency
#define F_CPU			9830400
 
//deboune timer
#define DEBOUNCE_PERIOD 	100 //interrupt every 2.6 ms.
#define NORMAL_DEBOUNCE 	200
#define SHORT_DEBOUNCE		10

//switch port	
#define SWITCHINPORT	PINC
#define SWITCHOUTPORT	PORTC
#define SWITCHDDR		DDRC
#define MODEPIN			PC0
#define UNITPIN			PC1
#define INCPIN			PC2
#define DECPIN			PC3
#define ZEROPIN			PC4

//encoder
#define ENCDDR			DDRD
#define ENCINPORT		PIND
#define	ENCCHA			PD2
#define ENCCHB			PD3
#define EFIG0			PD4
#define EFIG1			PD5
#define ENCSHIFT		0x02

//eeprom 

#define EETEST			0x01
#define EEMODE			0x05
#define EEUNIT			0x06
#define EESCREEN		0x07
#define EEMASK			0x08
#define EECOUNT			0x09
#define EESCALE			0x0D
#define EELABELF		0x0F
#define EELABELM		0x10
#define EEWIDTH			0x11
#define EEMODE0X		0x12
#define EEMODE0Y		0x13
#define EEMODE1X		0x14
#define EEMODE1Y		0x15
#define EEMODE2X		0x16
#define EEMODE2Y		0x17
#define EEMODE3X		0x18
#define EEMODE3Y		0x19
#define EEMODE4X		0x1A
#define EEMODE4Y		0x1B
#define EESCALEFACTOR	0x1C


//eeprom values
#define UNIT_NONE		0x0
#define	SCRN_SN			0x0
#define SCRN_SP			0x1
#define SCRN_LN			0x2
#define SCRN_LP			0x3


//spi 
#define DDR_SPI 		DDRB
#define PORT_SPI		PORTB

#define DD_MOSI 		PB3
#define DD_MISO			PB4
#define DD_SCK			PB5
#define DD_SS			PB2

double CountToMetric(double val);
void CountToAscii(double value);
void MCUInit(void);
void Refresh(void);
#endif
