//fastencoder.S
#include <avr/io.h>
//#include "XBOB4EncInt.h"

;registers used
;r16 last encoder state
;r18 current encoder state
;r25 temp

state0 = 0
state1 = 4
state2 = 12
state3 = 8

.global INT0_vect
INT0_vect:
;push used registers
	push	r16
	push	r18
	push	r25
;push SREG
	in		r25,_SFR_IO_ADDR(SREG)
	push	r25
;toggle the LED
	in		r18,_SFR_IO_ADDR(PORTB)
	ldi		r25,1
	eor		r18,r25
	out		_SFR_IO_ADDR(PORTB),r18

;get last state and put in high reg for comparison tests
	mov		r16,r6

;get current state of encoder inputs keeping it in r18(value)
	in		r18,_SFR_IO_ADDR(PIND)
	andi	r18,0x0c

;state machine is based on last state of encoder inputs(r16)
;count is changed on transition between state0 and state3
;test for state 0
	cpi		r16,state0
	brne	continue_0

;last state was 0 
;valid states 1
state_0_0:
	cpi		r18,state1
	breq	exit_0
	rjmp	invalid_0

continue_0:
;test for state 3
	cpi		r16,state3
	brne	continue_again_0

;last state was 3 
;valid states 2
state_3_0:
	cpi		r18,state2
	breq	exit_0
	rjmp	invalid_0

continue_again_0:

;test for state 1
	cpi		r16,state1
	brne	state_2_0
state_1_0:
;last state was 1 
;valid states 0,2
	cpi		r18,state0
	breq	exit_0
	rjmp	invalid_0

;last state was 2 
;valid state 3
;disallow transition to state 0 (0)
state_2_0:
	cpi		r18,state3
	breq	exit_0
	rjmp	invalid_0

exit_0:
;lastvalue = value
	mov		r6,r18
invalid_0:
;restore SREG
	pop		r25
	out		_SFR_IO_ADDR(SREG),r25
;restore pushed registers
	pop		r25
	pop		r18
	pop		r16
;and we are out of here
	reti


.global INT1_vect
INT1_vect:
;push used registers
	push	r16
	push	r18
	push	r25
;push SREG
	in		r18,_SFR_IO_ADDR(SREG)
	push	r18
;toggle the LED
	in		r18,_SFR_IO_ADDR(PORTB)
	ldi		r25,2
	eor		r18,r25
	out		_SFR_IO_ADDR(PORTB),r18

;get last state and put in high reg for comparison tests
	mov		r16,r6

;get current state of encoder inputs keeping it in r18(value)
	in		r18,_SFR_IO_ADDR(PIND)
	andi	r18,0x0c

;state machine is based on last state of encoder inputs(r16)
;count is changed on transition between state0 and state3

;test for state 0
	cpi		r16,state0
	brne	continue_1

;last state was 0 
;valid states 1,3
;trigger decrement count at transition to state 3 (8)
state_0_1:
	cpi		r18,state3
	brne	invalid_1
;decrement count
decrement_1:
;zero r1
	eor		r1,r1
	ldi		r25,0x01
	sub		r2,r25
	sbc		r3,r1
	sbc		r4,r1
	sbc		r5,r1
	rjmp	exit_1

continue_1:
;test for state 3
	cpi		r16,state3
	brne	continue_again_1

;last state was 3 
;valid state 0
;trigger increment count at transition to state 0 (0)
state_3_1:
	cpi		r18,state0
	brne	invalid_1
increment_1:
;zero r1
	eor		r1,r1
 	ldi		r25,0x01
	add		r2,r25
	adc		r3,r1
	adc		r4,r1
	adc		r5,r1
	rjmp	exit_1	

continue_again_1:

;test for state 1
	cpi		r16,state1
	brne	state_2_1
state_1_1:
;last state was 1 
;valid state 2
	cpi		r18,state2
	breq	exit_1
	rjmp	invalid_1

;last state was 2 
;valid state 1
state_2_1:
	cpi		r18,state1
	breq	exit_1
	rjmp	invalid_1			
exit_1:
;lastvalue = value
	mov		r6,r18
invalid_1:
;restore SREG
	pop		r25
	out		_SFR_IO_ADDR(SREG),r25
;restore pused registers
	pop		r25
	pop		r18
	pop		r16
;and we are out of here
	reti

;these functions make the register variables available to the c code

.global get_count
;place count registers in memory variable count
get_count:
	sts		count,r2
	sts		count + 1,r3
	sts		count + 2,r4
	sts		count + 3,r5
	ret
.global set_count
;place contents of memory variable count in registers
set_count:
	lds		r2,count
	lds		r3,count + 1
	lds		r4,count + 2
	lds		r5,count + 3
	ret

