//spi.c
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>
#include <avr/wdt.h> 
#include <stdint.h>
#include <stdlib.h>

#include "XBOB4EncInt.h"
#include "spi.h"
#include "uart.h"

void SpiInit(void)
{
	/* Set MOSI and SCK and SS output, all others input */
	DDR_SPI |= (1<<DD_MOSI)|(1<<DD_SCK)|(1<<DD_SS);
	//Bring SS high
	PORT_SPI |= (1<<DD_SS);
	/* Enable SPI, Master, set clock rate fck/16 */
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR0)|(1<<CPHA)|(1<<CPOL);
}
/**********************************************/

void SpiPutChar(uint8_t val)
{
	/* Start transmission */
	//bring SS low
	PORT_SPI &= ~(1<<DD_SS);
	SPDR = val;
	/* Wait for transmission complete */
	while(!(SPSR & (1<<SPIF)));
	//bring SS back high
	PORT_SPI |= (1<<DD_SS);
}
/**********************************************/

void SpiSendString(const char *str)
{
	//loop through a char array until value equals zero
	//signifying the end of the string 
	uint8_t index = 0;
	while(str[index])
	{
		SpiPutChar(str[index]);
		index++;
	}
}
/**********************************************/

