

//uart.c
//uart initialization and low level routines


#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>

#include "XBOB4EncInt.h"
#include "uart.h"

void UartInit(void)
{
	//clear the com buffer
	ReadPointer = 0;
	WritePointer = 0;
	memset(&ComBuffer,0,sizeof(ComBuffer));

	//set TXD to output
	DDRD |= (1<<PD1);

	//UartFlag = FALSE;
	//set baud rate to 9600
	UBRR0H = 0;
	UBRR0L = 63;	
	//enable transmit and interrupt driven recieve
	UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0);
	//8,N,1
	UCSR0C = (1<<UCSZ00)|(1<<UCSZ01);
	//Dummy read to clear RXC bit
	unsigned char temp;
	temp = UDR0;
}
/**********************************************/

void PutChar(char outchar)
{
	//send one character out uart
	loop_until_bit_is_set(UCSR0A,UDRE0);
	UDR0 = outchar;
}
/**********************************************/

char GetChar(void)
{	
	//retrieve one character from buffer
	char ret = ComBuffer[ReadPointer];
	ReadPointer++;
	if (ReadPointer == COMBUFFERSIZE)
		ReadPointer = 0;
	return ret;
}
/**********************************************/

void SendString(const char *str)
{
	unsigned int index = 0;
	while(str[index] != 0)
	{
		if (str[index] == 0x1b)
		{
			PutChar('<');
			PutChar('E');
			PutChar('S');
			PutChar('C');
			PutChar('>');
			index++;
		}
		else
		{
			PutChar(str[index++]);
		}
	}

}
/**********************************************/

ISR(USART_RX_vect)
{
	//uart recieve interrupt
	ComBuffer[WritePointer] = UDR0;
	WritePointer++;
	if (WritePointer == COMBUFFERSIZE)
		WritePointer = 0;
}
/**********************************************/



